<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <meta http-equiv="X-UA-Compatible" content="ie=edge">
    <title>Document</title>
</head>
<body>
    <div id="d1"></div>
    <div id="d2"></div>
    <div id="d3"></div>
    <div id="d4"></div>
    
    
    <script>

        const createRandArray = (size) =>
        {
            var arr = [];
            for (let i = 0; i < size; i++)
                arr.push(Math.round(Math.random * 1000000));

            return arr;
        }

        const executeWithTimeMeasure = (func) =>
        {
            var start = Date.now();
            func();
            var end = Date.now();
            return end - start;
        }

        const sortMainThread = () => 
        {
            var arr = createRandArray(100000);
            document.querySelector('#d1').innerHTML = "Elapsed time (single main thread): " + executeWithTimeMeasure(() => {
                arr.sort();
            });
        }

        const sortInWorker = () => 
        {
            var arr = createRandArray(100000);
            
            var start = Date.now();
            const worker = new Worker('./WorkerFunction.js');
            worker.postMessage(arr);            
            var end = Date.now();
            var time = end - start;
            worker.addEventListener('message', e => {
                document.querySelector('#d2').innerHTML = "Elapsed time (single worker thread): " + time;
            });
            worker.postMessage(time);
        }

        const sortMultiMainThread = () => 
        {
            var arr1 = createRandArray(100000);
            var arr2 = createRandArray(100000);
            var arr3 = createRandArray(100000);
            var arr4 = createRandArray(100000);
            document.querySelector('#d3').innerHTML = "Elapsed time (multiple main thread): " + executeWithTimeMeasure(() => {
                arr1.sort();
                arr2.sort();
                arr3.sort();
                arr4.sort();
            });
        }

        const sortMultiInWorker = () => 
        {
            var arr1 = createRandArray(100000);
            var arr2 = createRandArray(100000);
            var arr3 = createRandArray(100000);
            var arr4 = createRandArray(100000);
            
            var start = Date.now();
            const worker = new Worker('./WorkerFunction.js');
            worker.postMessage(arr1);            
            worker.postMessage(arr2);            
            worker.postMessage(arr3);            
            worker.postMessage(arr4);            
            var end = Date.now();
            var time = end - start;            
            worker.addEventListener('message', e => {                
                document.querySelector('#d4').innerHTML = "Elapsed time (multiple worker thread): " + time;
            });
            worker.postMessage(time);

        }
        
        sortMainThread();
        sortInWorker();
        sortMultiMainThread();
        sortMultiInWorker();
    
    </script>
</body>
</html>